﻿Type=Service
Version=5.5
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
	#ExcludeFromLibrary: True
#End Region
    Sub Process_Globals
       Private session As JavaObject
    End Sub

    Sub Service_Create
       Dim context As JavaObject
       context.InitializeContext
       session.InitializeNewInstance("android.media.session.MediaSession", Array(context, "tag"))

       Dim cb As JavaObject
       cb.InitializeNewInstance(Application.PackageName & ".starter.MyCallback", Null)
        session.RunMethod("setCallback", Array(cb))
     
        session.RunMethod("setFlags",Array(3))
        session.RunMethod("setActive", Array(True))
    End Sub

    Sub Service_Start (StartingIntent As Intent)

    End Sub

    'Return true to allow the OS default exceptions handler to handle the uncaught exception.
    Sub Application_Error (Error As Exception, StackTrace As String) As Boolean
        Return True
    End Sub

    Sub Service_Destroy
        session.RunMethod("release",Null)
    End Sub
    Sub Media_OnCommand(Command As String)
       Log(Command)
    End Sub
    
	Sub Media_OnButton(Intent As Intent) As Boolean
        
		Log(Intent.Action)
		Log(Intent.ExtrasToString)
		
		process_intent(Intent)
		Return True
		
		
    End Sub
	
		
Sub process_intent(i As Intent )

	Dim sf As StringFunctions
	Dim v As PhoneVibrate

	sf.Initialize 
	
	If sf.InString(i.ExtrasToString,"action=ACTION_DOWN") >= 0 Then
		v.Vibrate(100) 
		' // start press count
		If Main.pressTime = 0 Then
			Main.pressTime = DateTime.Now
			Log(DateTime.Time(DateTime.Now) & " Start Button Press")
		End If
		CallSub(Main,"clear_list")

	End If

	If sf.InString(i.ExtrasToString,"action=ACTION_UP") >= 0 Then
		Log(DateTime.Time(DateTime.Now) & Round2((DateTime.Now - Main.pressTime) / DateTime.TicksPerSecond,2))
		Main.pressTime = 0
		Log(DateTime.Time(DateTime.Now) & " End Button Press")
	End If

	CallSub2(Main,"add_intent",i)
	
	
	
End Sub
	
    #if java
    import android.media.session.MediaSession.*;
    import android.os.Bundle;
    import android.os.ResultReceiver;
    import android.content.Intent;
    import anywheresoftware.b4a.objects.IntentWrapper;
    public static class MyCallback extends Callback {
       public MyCallback() {
       }
       public void onCommand(String command, Bundle args, ResultReceiver cb) {
       BA.Log(command);
         processBA.raiseEventFromUI(null, "media_oncommand", command);
       }
       public boolean onMediaButtonEvent(Intent mediaButtonIntent) {
         IntentWrapper baIntent = new IntentWrapper();
         baIntent.setObject(mediaButtonIntent);
        Boolean b = (Boolean) processBA.raiseEvent(null, "media_onbutton", baIntent);
        return b == null ? false : b;
       }
    }
    #end if

     

